{===============================================================================|
 |                                                                              |
 |                             H E R E A   S O F T                              |
 |                             Unit : RichOle.pas                              |
 |                        Ecrit par : Alexandre le Grand                        |
 |                  e-mail : alexandre.le.grand@libertysurf.fr                  |
 |                      Copyright : (c)jeudi 31 aot 2000                       |
 |                                                                              |
 |                               Version : 1.0.0                                |
 |                                                                              |
 |==============================================================================|}

Unit
  RichOle;

Interface

Uses
  Windows, ActiveX, Richedit;

Type
  TREObject = Packed Record
    cbStruct : DWORD; 
    cp : longint; 
    clsid : TCLSID; 
    oleobj : IOleObject; 
    stg : IStorage; 
    olesite : IOLEClientSite; 
    SIZEL : TSize; 
    dvaspect : DWORD; 
    dwFlags : DWORD; 
    dwUser : DWORD 
  End;

  
Const
  REO_GETOBJ_NO_INTERFACES = $00000000;
  REO_GETOBJ_POLEOBJ = $00000001;
  REO_GETOBJ_PSTG = $00000002;
  REO_GETOBJ_POLESITE = $00000004;
  REO_GETOBJ_ALL_INTERFACES = $00000007;

  REO_CP_SELECTION = $FFFFFFFF; 
  REO_IOB_SELECTION = $FFFFFFFF; 
  REO_IOB_USE_CP = $FFFFFFFE; 

  REO_NULL = $00000000; 
  REO_READWRITEMASK = $0000003F; 
  REO_DONTNEEDPALETTE = $00000020; 
  REO_BLANK = $00000010; 
  REO_DYNAMICSIZE = $00000008; 
  REO_INVERTEDSELECT = $00000004; 
  REO_BELOWBASELINE = $00000002; 
  REO_RESIZABLE = $00000001; 
  REO_LINK = $80000000; 
  REO_STATIC = $40000000; 
  REO_SELECTED = $08000000; 
  REO_OPEN = $04000000; 
  REO_INPLACEACTIVE = $02000000; 
  REO_HILITED = $01000000; 
  REO_LINKAVAILABLE = $00800000; 
  REO_GETMETAFILE = $00400000; 

  RECO_PASTE = $00000000;
  RECO_DROP = $00000001;
  RECO_COPY = $00000002;
  RECO_CUT = $00000003;
  RECO_DRAG = $00000004;

  
  
Type
  IRichEditOle = Interface(IUnknown)
    ['{00020d00-0000-0000-c000-000000000046}']
    Function GetClientSite(Out clientSite : IOleClientSite) : HResult;Stdcall;
    Function GetObjectCount : HResult;Stdcall;
    Function GetLinkCount : HResult;Stdcall;
    Function GetObject(iob : Longint;Out reobject : TReObject;
      dwFlags : DWORD) : HResult;Stdcall;
    Function InsertObject(Var reobject : TReObject) : HResult;Stdcall;
    Function ConvertObject(iob : Longint;rclsidNew : TIID;
      lpstrUserTypeNew : LPCSTR) : HResult;Stdcall;
    Function ActivateAs(rclsid : TIID;rclsidAs : TIID) : HResult;Stdcall;
    Function SetHostNames(lpstrContainerApp : LPCSTR;
      lpstrContainerObj : LPCSTR) : HResult;Stdcall;
    Function SetLinkAvailable(iob : Longint;fAvailable : BOOL) : HResult;Stdcall;
    Function SetDvaspect(iob : Longint;dvaspect : DWORD) : HResult;Stdcall;
    Function HandsOffStorage(iob : Longint) : HResult;Stdcall;
    Function SaveCompleted(iob : Longint;Const stg : IStorage) : HResult;Stdcall;
    Function InPlaceDeactivate : HResult;Stdcall;
    Function ContextSensitiveHelp(fEnterMode : BOOL) : HResult;Stdcall;
    Function GetClipboardData(Var chrg : TCharRange;reco : DWORD;
      Out dataobj : IDataObject) : HResult;Stdcall;
    Function ImportDataObject(dataobj : IDataObject;cf : TClipFormat;
      hMetaPict : HGLOBAL) : HResult;Stdcall;
  End;

  
  
  IRichEditOleCallback = Interface(IUnknown)
    ['{00020d03-0000-0000-c000-000000000046}']
    Function GetNewStorage(Out stg : IStorage) : HResult;Stdcall;
    Function GetInPlaceContext(Out Frame : IOleInPlaceFrame;
      Out Doc : IOleInPlaceUIWindow;
      lpFrameInfo : POleInPlaceFrameInfo) : HResult;Stdcall;
    Function ShowContainerUI(fShow : BOOL) : HResult;Stdcall;
    Function QueryInsertObject(Const clsid : TCLSID;Const stg : IStorage;
      cp : Longint) : HResult;Stdcall;
    Function DeleteObject(Const oleobj : IOleObject) : HResult;Stdcall;
    Function QueryAcceptData(Const dataobj : IDataObject;
      Var cfFormat : TClipFormat;reco : DWORD;fReally : BOOL;
      hMetaPict : HGLOBAL) : HResult;Stdcall;
    Function ContextSensitiveHelp(fEnterMode : BOOL) : HResult;Stdcall;
    Function GetClipboardData(Const chrg : TCharRange;reco : DWORD;
      Out dataobj : IDataObject) : HResult;Stdcall;
    Function GetDragDropEffect(fDrag : BOOL;grfKeyState : DWORD;
      Var dwEffect : DWORD) : HResult;Stdcall;
    Function GetContextMenu(seltype : Word;Const oleobj : IOleObject;
      Const chrg : TCharRange;Out Menu : HMENU) : HResult;Stdcall;
  End;

Implementation

End.
